import { Machine } from "xstate"
import { createStore, applyMiddleware, combineReducers } from "redux"

import { createMiddleware, createReducer } from "../src"

const actionMap = {
  log: (dispatch, state) =>
    fetch(LOG_URL, {
      method: "POST",
      body: JSON.stringify(state)
    })
}
const stateChart = {
  key: "light",
  initial: "green",
  states: {
    green: {
      on: {
        TIMER: "yellow"
      }
    },
    yellow: {
      on: {
        TIMER: "red"
      }
    },
    red: {
      on: {
        TIMER: "green"
      },
      onEntry: ["log"]
    },
    states: {
      initial: "walk",
      states: {
        walk: {
          on: {
            PED_COUNTDOWN: "wait"
          }
        },
        wait: {
          on: {
            PED_COUNTDOWN: "stop"
          }
        },
        stop: {}
      }
    }
  }
}

const machine = Machine(stateChart)

const store = createStore(
  combineReducers({
    machine: createReducer(machine.initialState)
  }),
  applyMiddleware(createMiddleware(machine, actionMap))
)

store.dispatch({
  type: "TIMER"
})

console.log(store.getState().machine)


store.dispatch({
  type: "TIMER"
})

console.log(store.getState().machine)

